/*
 * Copyright (c) 2013, Linz Center of Mechatronics GmbH (LCM), web: www.lcm.at
 * All rights reserved.
 */
/*
 * This file is licensed according to the BSD 3-clause license as follows:
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the "Linz Center of Mechatronics GmbH" and "LCM" nor
 *       the names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL "Linz Center of Mechatronics GmbH" BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
/*
 * This file is part of X2C. web: x2c.lcm.at
 * $LastChangedRevision: 4463 $
 * $LastChangedDate:: 2026-08-17 13:59:56 +0200#$
 */
/* USERCODE-BEGIN:Description */
/* Description: */
/* USERCODE-END:Description */

package at.lcm.x2c.library.control;

import at.lcm.x2c.core.structure.*;
import at.lcm.bu21.general.dtypes.*;

/* USERCODE-BEGIN:Imports */
/* USERCODE-END:Imports */

@SuppressWarnings("unused")
public class ConvFnc_TF1_Float32 extends JavaConversionFunction {
    private static final long serialVersionUID = 1L;

    @Override
    public void convertMaskToImplementation() throws Exception {
        MaskDouble b1MaskVal = (MaskDouble)this.getMaskParameter("b1").getMaskDataType();
        TNumeric b1MaskData = (TNumeric)b1MaskVal.getData();
        double mp_b1 = b1MaskData.getReal(0, 0);
        MaskDouble b0MaskVal = (MaskDouble)this.getMaskParameter("b0").getMaskDataType();
        TNumeric b0MaskData = (TNumeric)b0MaskVal.getData();
        double mp_b0 = b0MaskData.getReal(0, 0);
        MaskDouble a0MaskVal = (MaskDouble)this.getMaskParameter("a0").getMaskDataType();
        TNumeric a0MaskData = (TNumeric)a0MaskVal.getData();
        double mp_a0 = a0MaskData.getReal(0, 0);
        MaskDouble ts_factMaskVal = (MaskDouble)this.getMaskParameter("ts_fact").getMaskDataType();
        TNumeric ts_factMaskData = (TNumeric)ts_factMaskVal.getData();
        double mp_ts_fact = ts_factMaskData.getReal(0, 0);

        TNumeric b0CtrVal = this.getImplementationParameterData("b0");
        double cp_b0 = Double.NaN;
        TNumeric b1CtrVal = this.getImplementationParameterData("b1");
        double cp_b1 = Double.NaN;
        TNumeric a0CtrVal = this.getImplementationParameterData("a0");
        double cp_a0 = Double.NaN;

        /* Check if sample time factor is an integer value */
        if (Math.rint(mp_ts_fact) != mp_ts_fact) {
            throw new Exception("Sample time factor must be a whole number");
        }
        /* Check if sample time factor is within the valid range (upper limit defined by unsigned 16-bit integer range) */
        if ((mp_ts_fact < 1.0) || (mp_ts_fact > 65535.0)) {
            throw new Exception("Sample time factor must be at least 1 and at most 65535");
        }
        /* Block sample time */
        double bp_ts = mp_ts_fact * this.getDedicatedBlock().getModel().getSampleTime();
        /* Check if Block sample time has a valid value */
        if (bp_ts <= 0.0) {
            throw new Exception("Block sample time must be greater than zero");
        }

        /* ATTENTION: */
        /* The M2I conversion function may either use the mp_* or *MaskVal value to get the Mask Parameter value */
        /* For new or updated implementations, the mp_* value shall be used where possible */
        /* Currently, the mp_* value cannot be used for getting non-scalar Mask Parameter data but will return only the first element for these */
        /* The Implementation Parameter assignment variables cp_* can and shall be used for all Implementation Parameter data types */

        /* INFO: Implementation data assignment for array types when using the cp_* variables */
        /* If the cp_* parameter is a FLASH ARRAY, the cp_* variable is assigned an array type but without an actual array */
        /* The M2I conversion function has to assign an array with the correct size and fill it with content */
        /* If the cp_* parameter is a RAM ARRAY, the cp_* variable is assigned an array with the correct size */
        /* The first element is assigned an invalid value while the other elements are (auto)initialized with zero */
        /* The M2I conversion function has to fill the array with content */

        /* Mask parameter values */
        /* mp_b1 OR b1MaskVal (Number) */
        /* mp_b0 OR b0MaskVal (Number) */
        /* mp_a0 OR a0MaskVal (Number) */
        /* mp_ts_fact OR ts_factMaskVal (Number) */

        /* USERCODE-BEGIN:ConvMaskToImplementation */
		// get mask value and set controller parameter
		b0CtrVal.setReal(0, 0, Double.valueOf(b0MaskVal.getValue()));
		b1CtrVal.setReal(0, 0, Double.valueOf(b1MaskVal.getValue()));
		a0CtrVal.setReal(0, 0, Double.valueOf(a0MaskVal.getValue()));

        /* USERCODE-END:ConvMaskToImplementation */

        /* Implementation Parameter values */
        /* cp_b0 OR b0CtrVal (Value) */
        /* cp_b1 OR b1CtrVal (Value) */
        /* cp_a0 OR a0CtrVal (Value) */

        if (Double.isNaN(cp_b0)) {
            this.setImplementationParameterData("b0", b0CtrVal);
        } else {
            this.setImplementationParameterData("b0", new TNumeric(cp_b0));
        }
        if (Double.isNaN(cp_b1)) {
            this.setImplementationParameterData("b1", b1CtrVal);
        } else {
            this.setImplementationParameterData("b1", new TNumeric(cp_b1));
        }
        if (Double.isNaN(cp_a0)) {
            this.setImplementationParameterData("a0", a0CtrVal);
        } else {
            this.setImplementationParameterData("a0", new TNumeric(cp_a0));
        }
    }

    @Override
    public void convertImplementationToMask() throws Exception {
        MaskDouble b1MaskVal = (MaskDouble)this.getMaskParameter("b1").getMaskDataType();
        TNumeric b1MaskData = (TNumeric)b1MaskVal.getData();
        double mp_b1 = Double.NaN;
        MaskDouble b0MaskVal = (MaskDouble)this.getMaskParameter("b0").getMaskDataType();
        TNumeric b0MaskData = (TNumeric)b0MaskVal.getData();
        double mp_b0 = Double.NaN;
        MaskDouble a0MaskVal = (MaskDouble)this.getMaskParameter("a0").getMaskDataType();
        TNumeric a0MaskData = (TNumeric)a0MaskVal.getData();
        double mp_a0 = Double.NaN;
        MaskDouble ts_factMaskVal = (MaskDouble)this.getMaskParameter("ts_fact").getMaskDataType();
        TNumeric ts_factMaskData = (TNumeric)ts_factMaskVal.getData();
        double mp_ts_fact = ts_factMaskData.getReal(0, 0);

        TNumeric b0CtrVal = this.getImplementationParameterData("b0");
        double cp_b0 = b0CtrVal.getReal(0, 0);
        TNumeric b1CtrVal = this.getImplementationParameterData("b1");
        double cp_b1 = b1CtrVal.getReal(0, 0);
        TNumeric a0CtrVal = this.getImplementationParameterData("a0");
        double cp_a0 = a0CtrVal.getReal(0, 0);

        /* Check if sample time factor is an integer value */
        if (Math.rint(mp_ts_fact) != mp_ts_fact) {
            throw new Exception("Sample time factor must be a whole number");
        }
        /* Check if sample time factor is within the valid range (upper limit defined by unsigned 16-bit integer range) */
        if ((mp_ts_fact < 1.0) || (mp_ts_fact > 65535.0)) {
            throw new Exception("Sample time factor must be at least 1 and at most 65535");
        }
        /* Block sample time */
        double bp_ts = mp_ts_fact * this.getDedicatedBlock().getModel().getSampleTime();
        /* Check if Block sample time has a valid value */
        if (bp_ts <= 0.0) {
            throw new Exception("Block sample time must be greater than zero");
        }

        /* ATTENTION: */
        /* The I2M conversion function may either use the cp_* or *CtrlVal value to get the Implementation Parameter value */
        /* For new or updated implementations, the cp_* value shall be used for all Implementation Parameter data types */
        /* The Mask Parameter assignment variables cp_* shall be used where possible */
        /* Currently, the mp_* variable assignment value cannot be used for setting non-scalar Mask Parameter data */

        /* Implementation Parameter values */
        /* cp_b0 OR b0CtrVal (Value) */
        /* cp_b1 OR b1CtrVal (Value) */
        /* cp_a0 OR a0CtrVal (Value) */

        /* USERCODE-BEGIN:ConvImplementationToMask */
		// get controller parameter and set mask parameter
		b0MaskData.setReal(0, 0, b0CtrVal.getReal(0, 0));
		b1MaskData.setReal(0, 0, b1CtrVal.getReal(0, 0));
		a0MaskData.setReal(0, 0, a0CtrVal.getReal(0, 0));

        /* USERCODE-END:ConvImplementationToMask */

        /* Mask parameter values */
        /* mp_b1 OR b1MaskVal (Number) */
        /* mp_b0 OR b0MaskVal (Number) */
        /* mp_a0 OR a0MaskVal (Number) */
        /* mp_ts_fact OR ts_factMaskVal (Number) */

        if (Double.isNaN(mp_b1)) {
            this.getMaskParameter("b1").setValue(b1MaskData.toFullString());
        } else {
            this.getMaskParameter("b1").setValue(new TNumeric(mp_b1).toFullString());
        }
        if (Double.isNaN(mp_b0)) {
            this.getMaskParameter("b0").setValue(b0MaskData.toFullString());
        } else {
            this.getMaskParameter("b0").setValue(new TNumeric(mp_b0).toFullString());
        }
        if (Double.isNaN(mp_a0)) {
            this.getMaskParameter("a0").setValue(a0MaskData.toFullString());
        } else {
            this.getMaskParameter("a0").setValue(new TNumeric(mp_a0).toFullString());
        }
    }
}
